////////////////////////////////////////////////////////////////////////////
void drawDataPoints(ArrayList<MovieAttributes> list_of_movies){
  for (int movie_number = 0; movie_number < graph.num_of_titles; movie_number++) {
    moviePlotter(list_of_movies.get(movie_number));
    gradShader(list_of_movies.get(movie_number));
  }
}

void moviePlotter(MovieAttributes movie){
  stroke(204,0,100);
  strokeWeight(3);
  // graph.numRows-2 because line() takes two points at a time
  for (int i = 0; i < graph.numRows-2; i++) {
  //point(constantHorizontalMargin+graph.cellWidth*i,constantVerticalMargin-dataMatrix[i][0]);
  line(graph.time_locations[i],movie.y_up[i], graph.time_locations[i+1], movie.y_up[i+1]);
  line(graph.time_locations[i],movie.y_down[i], graph.time_locations[i+1], movie.y_down[i+1]);
  }
}

void gradShader(MovieAttributes movie){
  noStroke();
  //strokeWeight(4);
  for (int i=0; i< graph.numRows-2; i++){
    // grad[i+1] because first value will be 0
    color c = colorBar.get((int)map(movie.grad[i+1], 0, movie.grad_max, 5, colorBar.width-5), colorBar.height/2);
    fill(c);
    //fill(102,0,0);
    beginShape();
    vertex(graph.time_locations[i],movie.y_up[i]);
    vertex(graph.time_locations[i+1],movie.y_up[i+1]);
    vertex(graph.time_locations[i+1],movie.y_down[i+1]);
    vertex(graph.time_locations[i],movie.y_up[i]);// Huh, this mistake actually looks nicer.
    endShape(CLOSE);
  }
}
////////////////////////////////////////////////////////////////////////////

void graphLines(float horizontal_margin, float vertical_margin){
  //stroke(160,40,255);
  stroke(204,0,100);
  strokeWeight(3);
  //horizontal lines
  for (int line_rows=0; line_rows<graph.num_of_titles+1; line_rows++){
    line(horizontal_margin, vertical_margin+graph.cellHeight*line_rows, 
        horizontal_margin+graph.cellWidth*(graph.numRows-1),vertical_margin+graph.cellHeight*line_rows);
  }
  // vertical lines
  line(horizontal_margin+graph.cellWidth*(graph.numRows-1), vertical_margin, horizontal_margin+graph.cellWidth*(graph.numRows-1),vertical_margin+graph.cellHeight*4);
  line(horizontal_margin, vertical_margin, horizontal_margin,vertical_margin+graph.cellHeight*4);
  // vertical lines for releases
  stroke(204,0,100);
  strokeWeight(1);
  for (int i = 0; i < movie_release_dates_indexes.length; i++) {
    line(horizontal_margin+graph.cellWidth*movie_release_dates_indexes[i], vertical_margin,
        horizontal_margin+graph.cellWidth*movie_release_dates_indexes[i], vertical_margin+graph.cellHeight*4);
  };
}

void drawReleases(float constantHorizontalMargin, float constantVerticalMargin){
  textAlign(CENTER, CENTER);
  //fill(160,40,255);
  fill(0);
  textFont(newfont);
  textSize(12);
  text("First \n release", constantHorizontalMargin, constantVerticalMargin+graph.cellHeight*4+constantVerticalMargin/5);
  text("Second \n release", constantHorizontalMargin+graph.cellWidth*movie_release_dates_indexes[0], constantVerticalMargin+graph.cellHeight*4+constantVerticalMargin/5);
  text("Third \n release", constantHorizontalMargin+graph.cellWidth*movie_release_dates_indexes[1], constantVerticalMargin+graph.cellHeight*4+constantVerticalMargin/5);
  text("Fourth \n release", constantHorizontalMargin+graph.cellWidth*movie_release_dates_indexes[2], constantVerticalMargin+graph.cellHeight*4+constantVerticalMargin/5);

}

void drawTitles(float constantVerticalMargin){
  //Draw Title
  textAlign(CENTER, CENTER);
  textFont(newfont);
  textSize(32);
  text("Checkouts for Pirates of the Caribbean material From 2006-2018 By Month", width/2, constantVerticalMargin/2);
}

void drawHorizontalLabels(float constantVerticalMargin, float cellHeight){
  //Draw horizontal labels
  textAlign(CENTER, CENTER);
  textFont(newfont);
  textSize(22);
  text("Time in Months starting From January 2006", width/2, constantVerticalMargin+cellHeight*4+constantVerticalMargin/2);
}

void drawVerticalLabels(float constantHorizontalMargin, float cellHeight){
  fill(0);
  for(int i=0; i<graph.num_of_titles; i++){
    textAlign(RIGHT, CENTER);
    textFont(newfont);
    textSize(22);
    text(titles[i].toUpperCase(), constantHorizontalMargin-10, constantVerticalMargin +cellHeight*(0.5+i));
  }
}

void drawSlider(float value){
  strokeWeight(3);
  line(constantHorizontalMargin+value*graph.cellWidth, constantVerticalMargin, constantHorizontalMargin+value*graph.cellWidth, constantVerticalMargin+graph.cellHeight*4);
}
